/* Used to global, kernel */
struct con *con_hash[HASHSIZE];
struct con *current=NULL;
int watchfd, erase_issyn=0, current_input=1, mapped=0, raw_log=-1;
int ttyfd=-1,paused=0,playspeed=1, reachedEOF=0;
time_t gtime;
time_t lasttimeCT=0;
time_t lasttimeLP=0;
char *interface=NULL;
int xv=0;
int tick_frequency=50;
int ticks=0;
u_long lastack=0;
time_t ptime=0, delta_time=0;
time_t pkt_time=0;

struct con_row *row_list=NULL;
int cspos=0;
int purge_time=120;
int watched_rawlog=0;
char rawlog_filename[60];


/* Used to sniffer */
struct IP_header  IPhead;
struct TCP_header TCPhead;
struct ICMP_header ICMPhead;
struct UDP_header UDPhead;
struct unwrap info;

unsigned int TCP_nr_of_packets,ICMP_nr_of_packets;
unsigned int UDP_nr_of_packets,IP_nr_of_packets;
unsigned int TCP_bytes_in_packets,UDP_bytes_in_packets;

pcap_t *dev_desc;
int PROTO_HEAD;    /* Base Protocol head length (ethernet, PPP ,....) */
int NO_CHKSUM=1;  /* whether or not check sum */

char *IP_TYPE_precedence[8]=
{	"Routine", "Priority", "Immediate", "Flash", "Flash override",
        "Critical", "Internetwork control", "Network control"
};

char *IP_PROTOCOL_number[34]=
{
	"Reserved","ICMP","IGMP","GGP","Unassigned","ST","TCP","UCL","EGP",
	"IGP","BBN-MON","NVP-II","PUP","ARGUS","EMCOM","XNET","CHAOS","UDP",
	"MUX","DCN-MEAS","HMP","PRM","XNS-IDP","TRUNK-1","TRUNK-2","LEAF-1",
	"LEAF-2","RDP","IRTP","ISO-TP4","NETBLT","MFE-NSP","MERIT-INP","SEP"
};


char *ICMP_type_3_code[6]=
{
	"Net unreachable", "Host unreachable", "Protocol unreachable",
        "Port unreachable", "Fragmentation needed and DF set",
        "Source route failed"
};
char *ICMP_type_5_code[4]=
{
	"Redirect datagrams for the network",
        "Redirect datagrams for the host",
        "Redirect datagrams for the \'type of service\' and the network",
        "Redirect datagrams for the \'type of service\' and the host"
};
char *ICMP_type_11_code[2]=
{
	"Time-to-live exceeded in transmit",
	"Fragment reassembly time exceeded"
};


/* Used to debug */
FILE *debug_dev=NULL;

/* Used to decide service */
char *serv[1024];
struct Service *other_serv=NULL;

/* Used to decide log init value */
struct Log_init *loginit=NULL;

/* Used to exchange message between main process and tty */
int shmid=0;
int keyadd=0;
int sem=0;
pid_t *pid_term;
char *swapspace;
struct log_log *loghead=NULL;
fd_set rset,wset,allset;
int maxfd=0,maxi=0,numlog=0;

/* Used to config */
char *cfile="/usr/local/nxm/nxm.conf",*servfile,*filfile,*logstatfile,*connname,*icmplog;
FILE *logcon=NULL,*logicmp=NULL;

char *TERM="/usr/X11R6/bin/xterm";
char *TERM_PROGRAM="/usr/local/nxm/comm_tty";

